<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Efficiency</TITLE>
<link href="builder_45.html" rel=Next>
<link href="builder_43.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_43.html">previous</A>, <A HREF="builder_45.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC81" HREF="builder_toc.html#TOC81">Efficiency</A></H2>
<P>
The builder was written to help compiler writers manipulate small amounts of
the input program.  The builder was never intended to be an interface to
write front ends which generate full programs.  
 Most of the builder design decisions were taken in favor of ease of
programming over efficiency.
<A NAME="IDX713"></A>

</P>


<H3><A NAME="SEC82" HREF="builder_toc.html#TOC82">Execution Efficiency</A></H3>
<P>
The builder performs many semantic and syntactic checks on every operation.
The builder creates and maintains a large number of shadow structures.
When executing, it iterates many times over these shadow structues.
For example, parsing the type structues from type strings is very
inefficient.
<A NAME="IDX714"></A>

</P>


<H3><A NAME="SEC83" HREF="builder_toc.html#TOC83">Memory Utilization and Memory Leaks</A></H3>
<P>
The builder generates a large number of shadow structures. Since all the
building blocks are stored in uniform <CODE>block</CODE> structures, builder
creates a very large number of these structures.  Since the <CODE>block</CODE>
needs to handle all the possible cases, the structure itself is quite
large.  There are may places, especially in code generation, where
the builder is leaking memory.  This problem will be addressed in the next
release. 
<A NAME="IDX715"></A>
<A NAME="IDX716"></A>
<A NAME="IDX717"></A>
<A NAME="IDX718"></A>

</P>

<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_43.html">previous</A>, <A HREF="builder_45.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
